tasksToDelete = []
groupsToDelete = []

def action(step):
    global tasksToDelete,groupsToDelete
    tasksToDelete = []
    groupsToDelete = []
    system1 = GetSystem(Name="Study")
    importComponent1 = Study.CreateTask(
        Type="Import",
        System=system1)
    tasksToDelete.Add(importComponent1)
    study1 = system1.GetContainer(ComponentName="Study")
    import1 = importComponent1.GetTaskObject()
    geometryImportSource1 = study1.CreateEntity(
        Type="GeometryImportSource",
        Association=import1)
    geometryImportSource1.FilePath = step.Properties["Geometry"].Value
    geometryImportSource1.GenerateImportSourceOperation()
    
    step.UpdateProgressInformation(10.)

    pct = 10.
    for i in range(step.Properties["NAnalysis"].Value):
        meshingComponent1 = Study.CreateTask(
            Type="Meshing",
            System=system1,
            Input=importComponent1)
        tasksToDelete.Add(meshingComponent1)
        meshingComponent1.Refresh()
        physicsSolutionGroup1 = Study.CreateGroup(Name="Physics Solution")
        groupsToDelete.Add(physicsSolutionGroup1)
        physicsDefinitionComponent1 = Study.CreateTask(
            Type="Physics Definition",
            System=system1)
        tasksToDelete.Add(physicsDefinitionComponent1)
        solvePhysicsComponent1 = Study.CreateTask(
            Type="Solve Physics",
            System=system1)
        tasksToDelete.Add(solvePhysicsComponent1)
        physicsSolutionGroup1.Add(Component=physicsDefinitionComponent1)
        physicsSolutionGroup1.Add(Component=solvePhysicsComponent1)
        AddSourceToComponentInSystem(
            SourceComponent=physicsDefinitionComponent1,
            TargetComponent=solvePhysicsComponent1)
        AddSourceToComponentInSystem(
            SourceComponent=meshingComponent1,
            TargetComponent=physicsDefinitionComponent1)
        physicsDefinitionComponent1.Refresh()
        solvePhysicsComponent1.Refresh()
        physicsDefinition1 = physicsDefinitionComponent1.GetTaskObject()
        physicsRegion1 = study1.CreateEntity(
            Type="PhysicsRegion",
            Association=physicsDefinition1)
        solverSettings1 = study1.CreateEntity(
            Type="SolverSettings",
            Association=physicsDefinition1)
        transcript1 = study1.CreateEntity(
            Type="Transcript",
            Association=physicsDefinition1)
        physicsDefinitionComponent1.Refresh()
        solvePhysicsComponent1.Refresh()
        meshing1 = meshingComponent1.GetTaskObject()
        meshing1.EngineeringIntent = "StructuralOrThermalOrElectricConduction"
        physicsRegion1.Location = ["BODY1"]
        physicsRegion1.PhysicsType = "Structural"
        materialAssignment1 = study1.CreateEntity(
            Type="MaterialAssignment",
            Association=physicsDefinition1)
        materialAssignment1.Location = ["BODY1"]
        material1 = study1.CreateEntity(
            Type="Material",
            Association=physicsDefinition1)
        material1.ImportEngineeringData(Name="Structural Steel")
        materialAssignment1.Material = material1
        pct += 10.
        step.UpdateProgressInformation(pct)
        
        if i==9:
            raise UserErrorMessageException("My own error message.")
                
def reset(step):
    global tasksToDelete,groupsToDelete
    system1 = GetSystem(Name="Study")
    for group in groupsToDelete:
        Study.DeleteTaskGroup(Group=group)
    for task in tasksToDelete:
        task.DeleteTask(System=system1)
                   
def isvalid(step, prop):
    if prop.Value<1:
        prop.StateMessage = "Must be greater than 0."
        return False
    return True
    